package com.ejie.ab79.control;

import java.io.BufferedInputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletResponse;

import org.apache.commons.io.IOUtils;
import org.apache.commons.lang.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.ResponseStatus;
import org.springframework.web.bind.annotation.SessionAttributes;
import org.springframework.web.multipart.MultipartFile;

import com.ejie.ab79.clientesWS.ab61WebService.Ab61Exception;
import com.ejie.ab79.clientesWS.ab61WebService.DocumentoExpediente;
import com.ejie.ab79.clientesWS.ab61WebService.Usuario;
import com.ejie.ab79.comun.Constantes;
import com.ejie.ab79.model.actuaciones.RelActDoc;
import com.ejie.ab79.service.actuaciones.RelActDocService;
import com.ejie.ab79.webservice.adaptadores.PIFAdaptador;
import com.ejie.ab79.webservice.adaptadores.ab61WebServiceAdaptador;
import com.ejie.x38.control.bind.annotation.RequestJsonBody;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableResponseDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * RelActDocController  
 * 
 *  
 */
@SessionAttributes("usuario")
@Controller
@RequestMapping(value = "/relactdoc")

public class RelActDocController {

	private static final Logger logger = LoggerFactory.getLogger(RelActDocController.class);

	@Autowired
	private RelActDocService relActDocService;

	@Autowired
	private PIFAdaptador pifAdapterService;

	@Autowired
	private ab61WebServiceAdaptador ab61WebServiceAdaptador;

	/*
	 * OPERACIONES CRUD (Create, Read, Update, Delete)
	 * 
	 */

	/**
	 * Operacion CRUD Read. Devuelve el bean correspondiente al identificador
	 * indicado.
	 * 
	 * @param idRelActDoc
	 *            Integer
	 * @return RelActDoc Objeto correspondiente al identificador indicado.
	 */
	@RequestMapping(value = "/{idRelActDoc}", method = RequestMethod.GET)
	public @ResponseBody RelActDoc get(@PathVariable Integer idRelActDoc) {
		RelActDoc relActDoc = new RelActDoc();
		relActDoc.setIdRelActDoc(idRelActDoc);
		relActDoc = this.relActDocService.find(relActDoc);
		RelActDocController.logger.info("[GET - findBy_PK] : Obtener RelActDoc por PK");
		return relActDoc;
	}

	/**
	 * Devuelve una lista de beans correspondientes a los valores de filtrados
	 * indicados en el objeto pasado como parametro.
	 *
	 * @param filterRelActDoc
	 *            RelActDoc Objeto que contiene los parametros de filtrado
	 *            utilizados en la busqueda.
	 * @return List<RelActDoc> Lista de objetos correspondientes a la busqueda
	 *         realizada.
	 */
	@RequestMapping(method = RequestMethod.GET)
	public @ResponseBody List<RelActDoc> getAll(@ModelAttribute RelActDoc filterRelActDoc) {
		RelActDocController.logger.info("[GET - find_ALL] : Obtener RelActDoc por filtro");
		return this.relActDocService.findAll(filterRelActDoc, null);
	}

	/**
	 * Operacion CRUD Edit. Modificacion del bean indicado.
	 *
	 * @param relActDoc
	 *            RelActDoc Bean que contiene la informacion a modificar.
	 * @return RelActDoc Bean resultante de la modificacion.
	 */

	public @ResponseBody RelActDoc editEnviadoProSan(@RequestBody RelActDoc relActDoc) {
		RelActDoc relActDocAux = this.relActDocService.updateEnviadoProSan(relActDoc);
		RelActDocController.logger.info("[PUT] : RelActDoc actualizado correctamente");
		return relActDocAux;
	}

	/**
	 * Operacion CRUD Create. Creacion de un nuevo registro a partir del bean
	 * indicado.
	 *
	 * @param relActDoc
	 *            RelActDoc Bean que contiene la informacion con la que se va a
	 *            crear el nuevo registro.
	 * @return RelActDoc Bean resultante del proceso de creacion.
	 * @throws IOExcepdtion
	 */
	@RequestMapping(method = RequestMethod.POST)
	public @ResponseBody RelActDoc add(@ModelAttribute("relActDoc") RelActDoc relActDoc,
			@ModelAttribute("usuario") Usuario usuario,
			@RequestParam(value = "file", required = true) MultipartFile file) {

		return relActDoc;
	}

	/**
	 * Operacion CRUD Delete. Borrado del registro correspondiente al
	 * identificador especificado.
	 *
	 * @param idRelActDoc
	 *            Integer Identificador del objeto que se desea eliminar.
	 * @return RelActDoc Bean eliminado.
	 */
	@RequestMapping(value = "/{idRelActDoc}", method = RequestMethod.DELETE)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody RelActDoc remove(@PathVariable Integer idRelActDoc) {
		RelActDoc relActDoc = new RelActDoc();
		relActDoc.setIdRelActDoc(idRelActDoc);
		this.relActDocService.remove(relActDoc);
		RelActDocController.logger.info("[DELETE] : RelActDoc borrado correctamente");
		return relActDoc;
	}

	@RequestMapping(value = "/descargarDocumentoPid/{oidPid}/{nombreDocumento:.+}", method = RequestMethod.GET)
	public @ResponseBody void descargarDocumentoPid(@PathVariable String oidPid, @PathVariable String nombreDocumento,
			HttpServletResponse response) throws IOException {
		BufferedInputStream bIS = null;
		try {
			String pathPif = this.ab61WebServiceAdaptador.descargarDocumentoPid(oidPid, Constantes.CODIGO_APLICACION,
					Constantes.TIPO_URL_PARCIAL);
			if (!StringUtils.isEmpty(pathPif)) {
				response.setHeader("content-disposition", "attachment; filename=\"" + nombreDocumento + "\"");
				bIS = new BufferedInputStream(this.pifAdapterService.getFile(pathPif));
				IOUtils.copy(bIS, response.getOutputStream());
				response.flushBuffer();
			}
			RelActDocController.logger.info("descargarDocumentoPid : " + pathPif);
		} catch (Exception e) {
			RelActDocController.logger.error("descargarDocumentoPid - ERROR", e);
		} finally {
			if (bIS != null) {
				bIS.close();
			}
		}
	}

	@RequestMapping(value = "/descargarDocumentoDokusi/{oidDokusi}/{nombreDocumento:.+}", method = RequestMethod.GET)
	public @ResponseBody void descargarDocumentoDokusi(@PathVariable String oidDokusi,
			@PathVariable String nombreDocumento, HttpServletResponse response) throws IOException {

		BufferedInputStream bIS = null;
		try {
			String pathPif = this.ab61WebServiceAdaptador.descargarDocumentoDokusi(oidDokusi,
					Constantes.CODIGO_APLICACION, Constantes.TIPO_URL_PARCIAL);

			if (!StringUtils.isEmpty(pathPif)) {
				response.setHeader("content-disposition", "attachment; filename=\"" + nombreDocumento + "\"");
			}

			bIS = new BufferedInputStream(this.pifAdapterService.getFile(pathPif));
			IOUtils.copy(bIS, response.getOutputStream());
			response.flushBuffer();
		} catch (Exception e) {
			RelActDocController.logger.error("descargarDocumentoDokusi - ERROR", e);
		} finally {
			if (bIS != null) {
				bIS.close();
			}
		}

	}

	@RequestMapping(value = "/eliminarDocumento/{idDocumentoSubido}/{oidPid}", method = RequestMethod.DELETE)
	public @ResponseBody RelActDoc eliminarDocumento(@PathVariable Integer idDocumentoSubido,
			@PathVariable String oidPid) throws Ab61Exception {

		RelActDoc relActDoc = new RelActDoc();
		relActDoc.setIdDocumentoSubido(idDocumentoSubido);

		if (!"null".equals(oidPid)) {
			// Eliminamos el documento de PID
			this.ab61WebServiceAdaptador.eliminarDocumentoPid(oidPid);
			RelActDocController.logger.info("Documento eliminado de PID - " + oidPid);
		}

		// Eliminamos el documento de BBDD
		this.relActDocService.removeByIdDocumentoSubido(relActDoc);
		RelActDocController.logger.info("[DELETE] : RelActDoc borrado correctamente");

		return relActDoc;
	}

	@RequestMapping(value = "/obtenerDocumentosExpediente/{folderId}/{procedureId}", method = RequestMethod.GET)
	public @ResponseBody List<DocumentoExpediente> obtenerDocumentosExpediente(@PathVariable String folderId,
			@PathVariable String procedureId) {

		List<DocumentoExpediente> listaDocumentosExpediente = new ArrayList<DocumentoExpediente>();

		try {
			listaDocumentosExpediente = this.ab61WebServiceAdaptador.obtenerDocumentosExpediente(folderId, procedureId,
					1);
		} catch (Exception e) {
			RelActDocController.logger.error("obtenerDocumentosExpediente - ERROR", e);
		}
		return listaDocumentosExpediente;

	}

	/*
	 * METODOS COMPONENTE RUP_TABLE
	 * 
	 */

	/**
	 * Metodo de presentacion del RUP_TABLE.
	 * 
	 * @param model
	 *            Model
	 * @return String
	 */
	@RequestMapping(value = "/maint", method = RequestMethod.GET)
	public String getFormEdit(Model model) {
		RelActDocController.logger.info("[GET - View] : relactdoc");
		return "relactdoc";
	}

	/**
	 * Operacion de filtrado del componente RUP_TABLE.
	 * 
	 * @param filterRelActDoc
	 *            RelActDoc Bean que contiene los parametros de filtrado a
	 *            emplear.
	 * @param tableRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en el filtrado.
	 * @return TableResponseDto<RelActDoc> Dto que contiene el resultado del
	 *         filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/filter", method = RequestMethod.POST)
	public @ResponseBody TableResponseDto<RelActDoc> filter(
			@RequestJsonBody(param = "filter") RelActDoc filterRelActDoc,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		RelActDocController.logger.info("[POST - filter] : Obtener RelActDocs");
		return this.relActDocService.filter(filterRelActDoc, tableRequestDto, false);
	}

	/**
	 * Operacion de busqueda del componente RUP_TABLE.
	 * 
	 * @param filterRelActDoc
	 *            RelActDoc Bean que contiene los parametros de filtrado a
	 *            emplear.
	 * @param searchRelActDoc
	 *            RelActDoc Bean que contiene los parametros de busqueda a
	 *            emplear.
	 * @param tableRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en la búsqueda.
	 * @return TableRowDto<RelActDoc> Dto que contiene el resultado de la
	 *         busqueda realizada por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/search", method = RequestMethod.POST)
	public @ResponseBody List<TableRowDto<RelActDoc>> search(
			@RequestJsonBody(param = "filter") RelActDoc filterRelActDoc,
			@RequestJsonBody(param = "search") RelActDoc searchRelActDoc,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		RelActDocController.logger.info("[POST - search] : Buscar RelActDocs");
		return this.relActDocService.search(filterRelActDoc, searchRelActDoc, tableRequestDto, false);
	}

	/**
	 * Borrado multiple de registros
	 * 
	 * @param filterRelActDoc
	 *            RelActDoc Bean que contiene los parametros de filtrado a
	 *            emplear.
	 * @param tableRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en la busqueda.
	 * @return List<String> Lista de los identificadores de los registros
	 *         eliminados.
	 * 
	 */
	@RequestMapping(value = "/deleteAll", method = RequestMethod.POST)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody List<String> removeMultiple(@RequestJsonBody(param = "filter") RelActDoc filterRelActDoc,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		RelActDocController.logger.info("[POST - search] : [POST - removeMultiple] : Eliminar multiples RelActDocs");
		this.relActDocService.removeMultiple(filterRelActDoc, tableRequestDto, false);
		RelActDocController.logger.info("All entities correctly deleted!");

		return tableRequestDto.getMultiselection().getSelectedIds();
	}

	/*
	 * METODOS COMPONENTE RUP_TABLE - JERARQUIA
	 */

	/**
	 * Operacion de filtrado del componente RUP_TABLE para presentar los
	 * registros mediante visualizacion jerarquica.
	 * 
	 * @param filterRelActDoc
	 *            RelActDoc Bean que contiene los parametros de filtrado a
	 *            emplear.
	 * @param tableRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en el filtrado.
	 * @return TableResponseDto<JerarquiaDto<RelActDoc>> Dto que contiene el
	 *         resultado del filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/jerarquia/filter", method = RequestMethod.POST)
	public @ResponseBody TableResponseDto<JerarquiaDto<RelActDoc>> jerarquia(
			@RequestJsonBody(param = "filter") RelActDoc filterRelActDoc,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		RelActDocController.logger.info("[POST - jerarquia] : Obtener RelActDocs jerarquia");
		return this.relActDocService.jerarquia(filterRelActDoc, tableRequestDto, false);
	}

	/**
	 * Recupera los hijos de los registros desplegados en la visualizacion
	 * jerarquica.
	 * 
	 * @param filterRelActDoc
	 *            RelActDoc Bean que contiene los parametros de filtrado a
	 *            emplear.
	 * @param tableRequestDto
	 *            Dto que contiene los parametros de configuracion propios del
	 *            RUP_TABLE a aplicar en el filtrado.
	 * @return TableResponseDto<JerarquiaDto<RelActDoc>> Dto que contiene el
	 *         resultado del filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/jerarquiaChildren", method = RequestMethod.POST)
	public @ResponseBody TableResponseDto<JerarquiaDto<RelActDoc>> jerarquiaChildren(
			@RequestJsonBody(param = "filter") RelActDoc filterRelActDoc,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		RelActDocController.logger.info("[POST - jerarquia] : Obtener RelActDocs jerarquia - Hijos");
		return this.relActDocService.jerarquiaChildren(filterRelActDoc, tableRequestDto);
	}

	/**
	 * EXPORTERS
	 */

	@RequestMapping(value = "/clipboardReport", method = RequestMethod.POST)
	protected @ResponseBody List<RelActDoc> getClipboardReport(
			@RequestJsonBody(param = "filter") RelActDoc filterRelActDoc,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		RelActDocController.logger.info("[POST - clipboardReport] : : Copiar multiples usuarios");
		return this.relActDocService.getMultiple(filterRelActDoc, tableRequestDto, false);
	}

}
